#!/usr/bin/perl

#Fehlerausgabe an Browser
use CGI::Carp qw(fatalsToBrowser);

# Dateiflock
use Fcntl qw(:DEFAULT :flock);

$aktueller_datum = &datumsroutine();
$datumswert = 0;
open (DATUM, "+<daten/datum.dat");
&lock(DATUM);
$inhalt = <DATUM>;
unless ($inhalt eq $aktueller_datum) {
$datumswert = 1;
truncate(DATUM,0);
seek(DATUM,0,0);
print DATUM $aktueller_datum;
}
&unlock(DATUM);
close (DATUM);

if ($datumswert) {

open(DATENFILE, "daten/texte.dat");
&lock(DATENFILE);
@linien = <DATENFILE>;
&unlock(DATENFILE);
close(DATENFILE);

$index = int(rand($#linien));
($idn,$rtext) = split(/\|/, $linien[$index]);
chomp($rtext);

open (AUSGABE, ">daten/ausgabe.dat");
&lock(AUSGABE);
print AUSGABE $rtext;
close AUSGABE;
}

open (DAT, "<daten/ausgabe.dat");
&lock(DAT);
$linie=<DAT>;
close DAT;

# Ausgabe
print "Content-Type: application/x-javascript\n\n";
print "document.write(\'$linie\');\n";

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Datum
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub datumsroutine {

($sec, $min, $stunde, $mtag, $mon, $jahr, $tag, $nr_tag, $isdst) = localtime(time);
$monat = $mon+1;
if($monat < 10) { $monat = "0$monat"; }
if($mtag < 10) { $mtag = "0$mtag"; }
$jahr = 1900 + $jahr;
$datum_tag_mon = "$jahr$monat$mtag";
return $datum_tag_mon;
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
# Dateilocking
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #
sub lock {
local($FILE) = @_;
flock($FILE,LOCK_EX);
}

sub unlock {
local($FILE) = @_;
flock($FILE,LOCK_UN);
}
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - #

